Attribute VB_Name = "PsApi"
'NT-Systemabfrage
Public Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVerInfo As OSVERSIONINFO) As Long

Public Type OSVERSIONINFO
  dwOSVersionInfoSize As Long
  dwMajorVersion As Long
  dwMinorVersion As Long
  dwBuildNumber As Long
  dwPlatformId As Long
  szCSDVersion As String * 128
End Type

'Deklarationen zu PSAPI.DLL
Public Declare Function EnumProcesses Lib "PSAPI.DLL" (lpidProcess&, ByVal cb&, cbNeeded&) As Long
Public Declare Function EnumProcessModules Lib "PSAPI.DLL" (ByVal hProcess&, lphModule&, ByVal cb&, lpcbNeeded&) As Long
Public Declare Function GetModuleBaseNameA Lib "PSAPI.DLL" (ByVal hProcess&, ByVal hModule&, ByVal lpBaseName$, ByVal nSize&) As Long
Public Declare Function GetModuleBaseNameW Lib "PSAPI.DLL" (ByVal hProcess&, ByVal hModule&, lpBaseName As Byte, ByVal nSize&) As Long
Public Declare Function GetModuleFileNameExA Lib "PSAPI.DLL" (ByVal hProcess&, ByVal hModule&, ByVal lpFileName$, ByVal nSize&) As Long
Public Declare Function GetModuleFileNameExW Lib "PSAPI.DLL" (ByVal hProcess&, ByVal hModule&, lpFileName As Byte, ByVal nSize&) As Long
Public Declare Function GetModuleInformation Lib "PSAPI.DLL" (ByVal hProcess&, ByVal hModule&, lpmodinfo As MODULEINFO, ByVal cb&) As Long

Public Type MODULEINFO
  lpBaseOfDll As Long
  SizeOfImage As Long
  EntryPoint As Long
End Type

'Funktionen zur Prozeberwachung
Public Declare Function EmptyWorkingSet Lib "PSAPI.DLL" (ByVal hProcess&) As Long
Public Declare Function QueryWorkingSet Lib "PSAPI.DLL" (ByVal hProcess&, ByVal pv&, ByVal cb&) As Long
Public Declare Function InitializeProcessForWsWatch Lib "PSAPI.DLL" (ByVal hProcess&) As Long
Public Declare Function GetWsChanges Lib "PSAPI.DLL" (ByVal hProcess&, lpWatchInfo As PSAPI_WS_WATCH_INFORMATION) As Long

Public Type PSAPI_WS_WATCH_INFORMATION
  FaultingPc As Long
  FaultingVa As Long
End Type

Public Declare Function GetMappedFileNameA Lib "PSAPI.DLL" (ByVal hProcess&, lpv&, lpFileName As Byte, ByVal nSize&) As Long
Public Declare Function GetMappedFileNameW Lib "PSAPI.DLL" (ByVal hProcess&, lpv&, ByVal lpFileName$, ByVal nSize&) As Long
Public Declare Function EnumDeviceDrivers Lib "PSAPI.DLL" (lpImageBase&, ByVal cb&, lpcbNeeded&) As Long
Public Declare Function GetDeviceDriverBaseNameA Lib "PSAPI.DLL" (ByVal lpImageBase&, ByVal lpBaseName$, ByVal nSize&) As Long
Public Declare Function GetDeviceDriverBaseNameW Lib "PSAPI.DLL" (ByVal lpImageBase&, lpBaseName As Byte, ByVal nSize&) As Long
Public Declare Function GetDeviceDriverFileNameA Lib "PSAPI.DLL" (ByVal lpImageBase&, ByVal lpFileName$, ByVal nSize&) As Long
Public Declare Function GetDeviceDriverFileNameW Lib "PSAPI.DLL" (ByVal lpImageBase&, lpFileName As Byte, ByVal nSize&) As Long
Public Declare Function GetProcessMemoryInfo Lib "PSAPI.DLL" (ByVal hProcess&, ppsmemCounters As PROCESS_MEMORY_COUNTERS, ByVal cb&) As Long

Public Type PROCESS_MEMORY_COUNTERS
  cb As Long
  PageFaultCount As Long
  PeakWorkingSetSize As Long
  WorkingSetSize As Long
  QuotaPeakPagedPoolUsage As Long
  QuotaPagedPoolUsage As Long
  QuotaPeakNonPagedPoolUsage As Long
  QuotaNonPagedPoolUsage As Long
  PagefileUsage As Long
  PeakPagefileUsage As Long
End Type

'allgemeine Prozessinfos (auch verfgbar unter W95)
'Prozess und zugehrige Threads beenden
Public Declare Function TerminateProcess Lib "kernel32" (ByVal hProcess&, ByVal uExitCode&) As Long
'Beendigungscode eines Prozesses zur Prozesskennung ermitteln
Public Declare Function GetExitCodeProcess Lib "kernel32" (ByVal hProcess&, lpExitCode&) As Long
'Prozesskennung ermitteln
Public Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal Buffer$, ByVal Size&) As Long
Public Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess&, ByVal bInheritHandle&, ByVal dwProcessId&) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject&) As Long
'Prozessesspeicher (nur unter NT)
Public Declare Function GetProcessWorkingSetSize Lib "kernel32" (ByVal hProcess&, lpMinWorkingSetSize&, lpMaxWorkingSetSize&) As Long
'Prozessprioritt ermitteln
Public Declare Function GetPriorityClass Lib "kernel32" (ByVal hProcess&) As Long
'Prozezeiten ermitteln (nur unter NT)
Public Declare Function GetProcessTimes Lib "kernel32" (ByVal hProcess&, lpCreate As FILETIME, lpExit As FILETIME, lpKernel As FILETIME, lpUser As FILETIME) As Long

Public Const PROCESS_ALL_ACCESS& = &H1F0FFF
Public Const PROCESS_CREATE_PROCESS& = &H80
Public Const PROCESS_CREATE_THREAD& = &H2
Public Const PROCESS_DUP_HANDLE& = &H40
Public Const PROCESS_QUERY_INFORMATION& = &H400
Public Const PROCESS_SET_INFORMATION& = &H200
Public Const PROCESS_SET_QUOTA& = &H100
Public Const PROCESS_TERMINATE& = &H1
Public Const PROCESS_VM_OPERATION& = &H8
Public Const PROCESS_VM_READ& = &H10
Public Const PROCESS_VM_WRITE& = &H20

Public Type FILETIME
  dwLowDateTime As Long
  dwHighDateTime As Long
End Type

'Zeitumwandlung
Declare Function FileTimeToLocalFileTime Lib "kernel32" (lpFileTime As FILETIME, lpLocalFileTime As FILETIME) As Long
Declare Function GetTimeFormat Lib "kernel32" Alias "GetTimeFormatA" (ByVal Locale As Long, ByVal dwFlags As Long, lpTime As SYSTEMTIME, ByVal lpFormat As Long, ByVal lpTimeStr As String, ByVal cchTime As Long) As Long
Declare Function GetDateFormat Lib "kernel32" Alias "GetDateFormatA" (ByVal Locale As Long, ByVal dwFlags As Long, lpDate As SYSTEMTIME, ByVal lpFormat As Long, ByVal lpDateStr As String, ByVal cchDate As Long) As Long
Public Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) As Long

Public Type SYSTEMTIME
  wYear As Integer
  wMonth As Integer
  wDayOfWeek As Integer
  wDay As Integer
  wHour As Integer
  wMinute As Integer
  wSecond As Integer
  wMilliseconds As Integer
End Type

Public Sub GetLocalTime(ZeitWert As FILETIME, Datum$, Zeit$, MilliSeconds&)
  'private, nicht ffentliche Konvertierfkt.:
  'Zeitwert vom Typ FILETIME in Zeitformat im Zeichenkettenformat umwandeln
  'ausgelesenen Zeitwert in lokalen Zeitwert umwandeln
  '(Bercksichtigung von bspw. Sommer-/Winterzeit)
  Dim LocalZeitwert As FILETIME
  'Umwandlung lokales Zeitformat (keine Strukturnderung)
  R& = FileTimeToLocalFileTime(ZeitWert, LocalZeitwert)
  Dim dummy As SYSTEMTIME
  'jetzt kann die lokale Zeit ausgelesen werden
  R& = FileTimeToSystemTime(LocalZeitwert, dummy)
  'Zeit in Millisekunden
  MilliSeconds& = dummy.wMilliseconds
  Zeit$ = Space$(255)
  R& = GetTimeFormat(0, 0, dummy, 0, Zeit$, Len(Zeit$))
  Zeit$ = Left$(Zeit$, R& - 1)
  Datum$ = Space$(255)
  R& = GetDateFormat(0, 0, dummy, 0, Datum$, Len(Datum$))
  Datum$ = Left$(Datum$, R& - 1)
End Sub

Function RInstr(Gesamt$, Zeichen$) As Long
  'Zeichen in einer Gesamtzeichenkette
  'beginnend von rechts durchsuchen
  If Len(Zeichen$) > 1 Then
      Zeichen$ = Left$(Zeichen$, 1)
    ElseIf Len(Zeichen$) = 0 Then
      Exit Function
  End If
  For x& = Len(Gesamt$) To 1 Step -1
    Z$ = Mid$(Gesamt$, x&, 1)
    If Z$ = Zeichen$ Then
      RInstr = x&
      Exit For
    End If
  Next x&
End Function

Function ProgramType$(Programm$)
  Prg$ = Programm$
  If InStr(Prg$, "\SystemRoot\") > 0 Then
    'NT meldet den Systempfad als Platzhalter zurck, der zur Ermittlung
    'des Programmtyps durch den tatschlichen Systempfad ersetzt werden mu
    Temp$ = Space$(256)
    vLen& = GetWindowsDirectory(Temp$, Len(Temp$))
    WinDir$ = Left$(Temp$, vLen&)
    'Systemverzeichnis in Zeichenkette als Ersatz fr Platzhalter bernehmen
    Prg$ = WinDir$ + Right$(Prg$, Len(Prg$) - 11)
  End If
  DNr = FreeFile
  Open Prg$ For Binary As #DNr
  'Offset Windows-Dateikopf
  Seek #DNr, &H3C + 1
  Get #DNr, , Offset&
  'Positionierung Windows-Dateikopf
  Seek #DNr, Offset& + 1
  'Windows-Kennung NE/PE auslesen
  Kennung$ = Space$(2)
  Get #DNr, , Kennung$
  If Kennung$ = "PE" Then
      '32-Bit-Programm
      ProgramType$ = "32-Bit"
    Else
      '16-Bit-Programm
      ProgramType$ = "16-Bit"
  End If
  Close #DNr
End Function

Public Function IsNT() As Boolean
  'Ist WinNT das aktuelle Betriebssystem?
  Const WIN_NT = 2
  Dim vInfo As OSVERSIONINFO
  vInfo.dwOSVersionInfoSize = Len(vInfo)
  dummy& = GetVersionEx(vInfo)
  If vInfo.dwPlatformId = WIN_NT Then
      IsNT = True
    Else
      IsNT = False
  End If
End Function
